Index: applications/demo/src/java/org/apache/jetspeed/demo/preferences/PreferencePortlet.java
===================================================================
RCS file: /home/cvspublic/jakarta-jetspeed-2/applications/demo/src/java/org/apache/jetspeed/demo/preferences/PreferencePortlet.java,v
retrieving revision 1.8
diff -u -b -r1.8 PreferencePortlet.java
--- applications/demo/src/java/org/apache/jetspeed/demo/preferences/PreferencePortlet.java	8 Mar 2004 00:04:41 -0000	1.8
+++ applications/demo/src/java/org/apache/jetspeed/demo/preferences/PreferencePortlet.java	1 Sep 2004 22:25:09 -0000
@@ -16,6 +16,8 @@
 package org.apache.jetspeed.demo.preferences;
 
 import java.io.IOException;
+import java.text.MessageFormat;
+import java.util.ResourceBundle;
 
 import javax.portlet.ActionRequest;
 import javax.portlet.ActionResponse;
@@ -46,8 +48,9 @@
     protected void doView(RenderRequest request, RenderResponse response) throws PortletException, IOException
     {
         PortletContext context = getPortletContext();
+        ResourceBundle resource = getPortletConfig().getResourceBundle(request.getLocale());
 
-        request.setAttribute("viewMessage", "My Mode is view.");
+        request.setAttribute("viewMessage", resource.getString("preference.label.MyModeIsView"));
 
         PortletRequestDispatcher rd = context.getRequestDispatcher("/WEB-INF/demo/preference/pref-view.jsp");
         rd.include(request, response);
@@ -67,6 +70,7 @@
      */
     public void processAction(ActionRequest request, ActionResponse response) throws PortletException, IOException
     {
+        ResourceBundle resource = getPortletConfig().getResourceBundle(request.getLocale());
         // Integer iCount = (Integer) request.getAttribute("org.apache.jetspeed.invocationCount");
         Integer iCount = (Integer) request.getPortletSession().getAttribute("org.apache.jetspeed.invocationCount");
         if (iCount == null)
@@ -79,9 +83,11 @@
 
         response.setRenderParameter("invocationCount", String.valueOf(count));
 
-        response.setRenderParameter("invokeMessage", "processAction() I was invoked " + count + " times!");
+        MessageFormat format = new MessageFormat(resource.getString("preference.label.processActionIWasInvoked"));
+        String[] patterns = { Integer.toString(count)};
+        response.setRenderParameter("invokeMessage", format.format(patterns));
         request.getPortletSession().setAttribute("org.apache.jetspeed.invocationCount", new Integer(count), PortletSession.PORTLET_SCOPE);
-        System.out.println("--------------------------- I was invoked!!!---------------------------------");
+        System.out.println(resource.getString("preference.label.IWasInvoked"));
     }
 
 }
