Index: applications/rss/src/java/org/apache/portals/applications/transform/TransformCacheEntry.java
===================================================================
RCS file: /home/cvspublic/jakarta-jetspeed-2/applications/rss/src/java/org/apache/portals/applications/transform/TransformCacheEntry.java,v
retrieving revision 1.1
diff -u -b -r1.1 TransformCacheEntry.java
--- applications/rss/src/java/org/apache/portals/applications/transform/TransformCacheEntry.java	15 Nov 2004 06:06:41 -0000	1.1
+++ applications/rss/src/java/org/apache/portals/applications/transform/TransformCacheEntry.java	24 Dec 2004 00:24:48 -0000
@@ -30,6 +30,7 @@
     protected Object document;
     protected long lastAccessed;
     protected long timeToLive = 15 * 60 * 1000; // in seconds, 15 minutes
+    protected String encoding;
     
     private TransformCacheEntry()
     {
@@ -44,17 +45,24 @@
      */
     public TransformCacheEntry(String key, Object document, long timeToLive)
     {
+        this(key, document, timeToLive, "UTF-8");
+    }
+
+    public TransformCacheEntry(String key, Object document, long timeToLive, String encoding)
+    {
         this.key = key;
         this.document = document;
         this.timeToLive = timeToLive;
         this.lastAccessed = new Date().getTime();
+        this.encoding=encoding;
     }
 
 
     /**
      * Set the cache's last accessed stamp
      *
-     * @param lastAccessed the cache's last access stamp
+     * @param lastAccessed
+     *               the cache's last access stamp
      */
     public void setLastAccessed(long lastAccessed)
     {
@@ -119,5 +127,19 @@
     public void setTimeToLive(long timeToLive)
     {
         this.timeToLive = timeToLive;
+    }
+    /**
+     * @return Returns the encoding.
+     */
+    public String getEncoding()
+    {
+        return encoding;
+    }
+    /**
+     * @param encoding The encoding to set.
+     */
+    public void setEncoding(String encoding)
+    {
+        this.encoding = encoding;
     }
 }
