Index: components/portlet-factory/src/java/org/apache/jetspeed/factory/JetspeedPortletFactory.java
===================================================================
RCS file: /home/cvspublic/jakarta-jetspeed-2/components/portlet-factory/src/java/org/apache/jetspeed/factory/JetspeedPortletFactory.java,v
retrieving revision 1.3
diff -u -b -r1.3 JetspeedPortletFactory.java
--- components/portlet-factory/src/java/org/apache/jetspeed/factory/JetspeedPortletFactory.java	15 Sep 2004 22:51:02 -0000	1.3
+++ components/portlet-factory/src/java/org/apache/jetspeed/factory/JetspeedPortletFactory.java	18 Sep 2004 22:15:12 -0000
@@ -16,7 +16,7 @@
 package org.apache.jetspeed.factory;
 
 import java.io.FileNotFoundException;
-import java.util.ArrayList;
+import java.util.HashMap;
 import java.util.Iterator;
 
 import javax.portlet.Portlet;
@@ -48,8 +48,8 @@
 {
 
     private PortletCache portletCache;
-    private final ArrayList classLoaders;
     private static final Log log = LogFactory.getLog(JetspeedPortletFactory.class);
+    private final HashMap classLoaderMap;
 
     /**
      * 
@@ -58,7 +58,7 @@
     {
         super();
         this.portletCache = portletCache;
-        classLoaders = new ArrayList(); 
+        classLoaderMap = new HashMap();
     }
 
     /**
@@ -71,16 +71,18 @@
      *
      * @param cl
      */
-    public void addClassLoader( ClassLoader cl )
+    public void addClassLoader(String paName, ClassLoader cl)
     {
-        synchronized(classLoaders)
+        if (paName != null && !paName.equals(""))
         {
-            if (!classLoaders.contains(cl))
+            synchronized (classLoaderMap)
             {
-            classLoaders.add(cl);
+                if (classLoaderMap.get(paName) == null)
+                {
+                    classLoaderMap.put(paName, cl);
+                }
             }
         }
-        
     }
 
     /**
@@ -109,10 +111,10 @@
         }
         catch (ClassNotFoundException e)
         {
-            synchronized(classLoaders)
+            synchronized (classLoaderMap)
             {
-                Iterator itr = classLoaders.iterator();
-                while(itr.hasNext() && portlet == null)
+                Iterator itr = classLoaderMap.values().iterator();
+                while (itr.hasNext() && portlet == null)
                 {
                     ClassLoader cl = (ClassLoader) itr.next();
                     try
@@ -155,6 +157,7 @@
         String portletName = portletDefinition.getId().toString();
         //String portletName = portletDefinition.getName();
         String className = portletDefinition.getClassName(); 
+        String paId=portletDefinition.getPortletApplicationDefinition().getWebApplicationDefinition().getId().toString();
 
         try
         {                        
@@ -172,7 +175,16 @@
                 throw new FileNotFoundException("Could not located portlet "+className+" in any classloader.");
             }
             
+            ClassLoader cl = (ClassLoader) classLoaderMap.get(paId);
+            if (cl != null)
+            {
+                ((PortletDefinitionCtrl) portletDefinition).setPortletClassLoader(cl);
+            }
+            else
+            {
             ((PortletDefinitionCtrl) portletDefinition).setPortletClassLoader(portlet.getClass().getClassLoader());
+            }
+      
             ServletContext servletContext = servletConfig.getServletContext();
             PortletContext portletContext = 
                         PortalAccessor.createPortletContext(servletContext, 
