Index: components/registry/src/java/org/apache/jetspeed/components/portletregistry/PortletRegistryComponentImpl.java
===================================================================
RCS file: /home/cvspublic/jakarta-jetspeed-2/components/registry/src/java/org/apache/jetspeed/components/portletregistry/PortletRegistryComponentImpl.java,v
retrieving revision 1.14
diff -u -b -r1.14 PortletRegistryComponentImpl.java
--- components/registry/src/java/org/apache/jetspeed/components/portletregistry/PortletRegistryComponentImpl.java	2 Jul 2004 13:31:56 -0000	1.14
+++ components/registry/src/java/org/apache/jetspeed/components/portletregistry/PortletRegistryComponentImpl.java	15 Aug 2004 12:18:35 -0000
@@ -29,6 +29,7 @@
 import org.apache.jetspeed.components.persistence.store.LockFailedException;
 import org.apache.jetspeed.components.persistence.store.PersistenceStore;
 import org.apache.jetspeed.om.common.MutableLanguage;
+import org.apache.jetspeed.om.common.Support;
 import org.apache.jetspeed.om.common.portlet.MutablePortletApplication;
 import org.apache.jetspeed.om.common.portlet.PortletDefinitionComposite;
 import org.apache.jetspeed.om.impl.LanguageImpl;
@@ -150,7 +151,19 @@
     {
         PersistenceStore store = getPersistenceStore();
         prepareTransaction(store);
-        return new ArrayList(store.getExtent(portletDefClass));
+        Collection pds = store.getExtent(portletDefClass);
+        Iterator itrPds = pds.iterator();
+        while (itrPds.hasNext())
+        {
+            try
+            {
+                ((Support) itrPds.next()).postLoad(this);
+            }
+            catch (Exception e)
+            {
+            }
+        }
+        return new ArrayList(pds);
     }
 
     public PersistenceStore getPersistenceStore()
@@ -174,7 +187,7 @@
         Filter filter = store.newFilter();
         filter.addEqualTo("id", new Long(id.toString()));
         Object query = store.newQuery(portletAppClass, filter);
-        return (MutablePortletApplication) store.getObjectByQuery(query);
+        return (MutablePortletApplication) postLoad(store.getObjectByQuery(query));
     }
 
     private void prepareTransaction(PersistenceStore store)
@@ -201,7 +214,7 @@
         Filter filter = store.newFilter();
         filter.addEqualTo("name", name);
         Object query = store.newQuery(portletAppClass, filter);
-        return (MutablePortletApplication) store.getObjectByQuery(query);
+        return (MutablePortletApplication) postLoad(store.getObjectByQuery(query));
     }
 
     /**
@@ -220,7 +233,7 @@
         Filter filter = store.newFilter();
         filter.addEqualTo("applicationIdentifier", ident);
         Object query = store.newQuery(portletAppClass, filter);
-        return (MutablePortletApplication) store.getObjectByQuery(query);
+        return (MutablePortletApplication) postLoad(store.getObjectByQuery(query));
     }
 
     /**
@@ -235,7 +248,19 @@
     {
         PersistenceStore store = getPersistenceStore();
         prepareTransaction(store);
-        return new ArrayList(store.getExtent(portletAppClass));
+        Collection pas = store.getExtent(portletAppClass);
+        Iterator itrPas = pas.iterator();
+        while (itrPas.hasNext())
+        {
+            try
+            {
+                ((Support) itrPas.next()).postLoad(this);
+            }
+            catch (Exception e)
+            {
+            }
+        }
+        return new ArrayList(pas);
     }
 
     /**
@@ -264,7 +289,7 @@
                 log.error(msg);
                 throw new IllegalStateException(msg);
             }
-            return getStoreableInstance(portlet);
+            return getStoreableInstance((PortletDefinitionComposite) postLoad(portlet));
         }
         else
         {
@@ -312,7 +337,7 @@
                 }
                 portlet.setPortletApplicationDefinition(app);
             }
-            return getStoreableInstance(portlet);
+            return getStoreableInstance((PortletDefinitionComposite)postLoad(portlet));
         }
         else
         {
@@ -514,5 +539,25 @@
         {
             return null;
         }
+    }
+    
+    private Object postLoad(Object obj)
+    {
+        if (obj == null)
+        {
+            return obj;
+        }
+
+        if (obj instanceof Support)
+        {
+            try
+            {
+                ((Support) obj).postLoad(obj);
+            }
+            catch (Exception e)
+            {
+            }
+        }
+        return obj;
     }
 }
