Index: components/registry/src/java/org/apache/jetspeed/om/impl/LanguageSetImpl.java
===================================================================
RCS file: /home/cvspublic/jakarta-jetspeed-2/components/registry/src/java/org/apache/jetspeed/om/impl/LanguageSetImpl.java,v
retrieving revision 1.12
diff -u -b -r1.12 LanguageSetImpl.java
--- components/registry/src/java/org/apache/jetspeed/om/impl/LanguageSetImpl.java	3 Apr 2005 23:28:15 -0000	1.12
+++ components/registry/src/java/org/apache/jetspeed/om/impl/LanguageSetImpl.java	6 Apr 2005 22:10:13 -0000
@@ -25,7 +25,6 @@
 import java.util.ResourceBundle;
 
 import org.apache.commons.lang.StringUtils;
-import org.apache.jetspeed.util.JetspeedLocale;
 import org.apache.jetspeed.om.common.MutableLanguage;
 import org.apache.jetspeed.om.common.Support;
 import org.apache.pluto.om.common.Language;
@@ -91,6 +90,8 @@
      */
     public Language get( Locale locale )
     {
+        System.out.println("TEST: LanguageSetImpl: get: locale="+locale);
+
         Language fallBack = null;
         Iterator searchItr = innerCollection.iterator();
         while (searchItr.hasNext())
@@ -99,10 +100,14 @@
 
             if (lang.getLocale().equals(locale))
             {
+                System.out.println("TEST: LanguageSetImpl: get: resources="+resources);
                 if (resources != null)
                 {
-                    return createLanguage(lang.getLocale(), loadResourceBundle(lang.getLocale()), lang.getTitle(), lang
-                            .getShortTitle(), StringUtils.join(lang.getKeywords(), ","), false);
+                    LanguageImpl language = (LanguageImpl)createLanguage(lang.getLocale(), loadResourceBundle(lang.getLocale()),"","","");
+                    language.setTitle(lang.getTitle());
+                    language.setShortTitle(lang.getShortTitle());
+                    language.setKeywords(StringUtils.join(lang.getKeywords(), ","));
+                    return language;
                 }
                 else
                 {
@@ -116,15 +121,30 @@
 
         }
 
+        System.out.println("TEST: LanguageSetImpl: get: 3");
         if (fallBack != null && resources != null)
         {
-            fallBack = createLanguage(fallBack.getLocale(), loadResourceBundle(fallBack.getLocale()), fallBack
-                    .getTitle(), fallBack.getShortTitle(), StringUtils.join(fallBack.getKeywords(), ","), true);
+            LanguageImpl language = (LanguageImpl)createLanguage(fallBack.getLocale(), loadResourceBundle(fallBack.getLocale()),"","","");
+            language.setTitle(fallBack.getTitle());
+            language.setShortTitle(fallBack.getShortTitle());
+            language.setKeywords(StringUtils.join(fallBack.getKeywords(), ","));
+            fallBack = language;
         }
 
+        System.out.println("TEST: LanguageSetImpl: get: 4");
         if (fallBack == null)
         {
-            fallBack = new LanguageImpl(locale, loadResourceBundle(locale));
+            if(!getDefaultLocale().equals(locale))
+            {
+                System.out.println("TEST: LanguageSetImpl: get: 5");
+                Language defaultLang=get(getDefaultLocale());
+                fallBack = new LanguageImpl(locale, loadResourceBundle(locale), defaultLang.getTitle(), defaultLang.getShortTitle(), StringUtils.join(defaultLang.getKeywords(), ","));
+            }
+            else
+            {
+                System.out.println("TEST: LanguageSetImpl: get: 6");
+                fallBack = new LanguageImpl(locale, loadResourceBundle(locale), "","","");
+            }
             innerCollection.add(fallBack);
         }
         return fallBack;
@@ -143,22 +163,48 @@
      */
     public boolean add( Object o )
     {
+        if (o instanceof Language)
+        {
         Language language = (Language) o;
         if (language.getLocale() == null)
         {
-            ((MutableLanguage) o).setLocale(Locale.ENGLISH);
+                ((MutableLanguage) o).setLocale(getDefaultLocale());
         }
 
+            Iterator ite = innerCollection.iterator();
+            while (ite.hasNext())
+            {
+                Language lang = (Language) ite.next();
+                if (lang.getLocale().equals(language.getLocale()))
+                {
+                    innerCollection.remove(lang);
+                    return innerCollection.add(o);
+                }
+            }
         return innerCollection.add(o);
     }
+        return false;
+    }
 
     /**
      * @see java.util.Collection#remove(java.lang.Object)
      */
-    public boolean remove( Object o )
+    public boolean remove(Object o)
+    {
+        if (o instanceof Language)
     {
         Language language = (Language) o;
-        return innerCollection.remove(language);
+            Iterator ite = innerCollection.iterator();
+            while (ite.hasNext())
+            {
+                Language lang = (Language) ite.next();
+                if (lang.getLocale().equals(language.getLocale()))
+                {
+                    return innerCollection.remove(lang);
+                }
+            }
+        }
+        return false;
     }
 
     /**
@@ -197,14 +243,39 @@
      */
     public void postLoad( Object parameter ) throws Exception
     {
+        System.out.println("TEST: LanguageSetImpl: postLoad:");
+        String title = "";
+        String shortTitle = "";
+        String keywords = "";
+        Language defaultLang = get(getDefaultLocale());
+        if (defaultLang != null)
+        {
+            title = defaultLang.getTitle();
+            shortTitle = defaultLang.getShortTitle();
+            keywords = StringUtils.join(defaultLang.getKeywords(), ",");
+        }
+        System.out.println("TEST: LanguageSetImpl: postLoad: default title="+title+", shortTitle="+shortTitle+", keywords="+keywords);
+
+        ResourceBundle defaultResource = loadResourceBundle(getDefaultLocale());
         Iterator iter = ((Collection) parameter).iterator();
         while (iter.hasNext())
         {
             Locale locale = (Locale) iter.next();
-            Language language = createLanguage(locale, null);
-            remove(language);
+            System.out.println("TEST: LanguageSetImpl: postLoad: locale="+locale.toString());
+            ResourceBundle resource = loadResourceBundle(locale);
+            if (resource == null)
+            {
+                resource = defaultResource;
+                System.out.println("TEST: LanguageSetImpl: postLoad: default resources="+resources);
+            }
+            Language language = createLanguage(locale, resource, title, shortTitle, keywords);
+            System.out.println("TEST: LanguageSetImpl: postLoad: title="+language.getTitle()+", shortTitle="+language.getShortTitle()+", keywords="+language.getKeywords());
             add(language);
         }
+
+        // add default Language
+        Language language = createLanguage(getDefaultLocale(), defaultResource, title, shortTitle, keywords);
+        add(language);
     }
 
     protected ResourceBundle loadResourceBundle( Locale locale )
@@ -252,6 +323,8 @@
      */
     private Language createLanguage( Locale locale, ResourceBundle bundle )
     {
+        System.out.println("TEST: LanguageSetImpl: createLanguage1: locale="+locale);
+
         String title = "";
         String shortTitle = "";
         String keywords = "";
@@ -263,7 +336,7 @@
             shortTitle = defaultLang.getShortTitle();
             keywords = StringUtils.join(defaultLang.getKeywords(), ",");
         }
-        return createLanguage(locale, bundle, title, shortTitle, keywords, false);
+        return createLanguage(locale, bundle, title, shortTitle, keywords);
     }
 
     /**
@@ -276,31 +349,10 @@
      * @param keywords
      * @return
      */
-    private Language createLanguage( Locale locale, ResourceBundle bundle, String title, String shortTitle,
-            String keywords, boolean createNow)
-    {
-        if (!createNow && !locale.equals(getDefaultLocale()))
-        {
-            Language defaultLang = get(getDefaultLocale());
-
-            if (defaultLang != null)
-            {
-                if (title == null || title.length() < 1)
+    private Language createLanguage( Locale locale, ResourceBundle bundle, String title, String shortTitle, String keywords)
                 {
-                    title = defaultLang.getTitle();
-                }
+        System.out.println("TEST: LanguageSetImpl: createLanguage2: locale="+locale);
 
-                if (shortTitle == null || shortTitle.length() < 1)
-                {
-                    shortTitle = defaultLang.getShortTitle();
-                }
-
-                if (keywords == null || keywords.length() < 1)
-                {
-                    keywords = StringUtils.join(defaultLang.getKeywords(), ",");
-                }
-            }
-        }
         LanguageImpl lang = new LanguageImpl(locale, bundle, title, shortTitle, keywords);
         return (Language) lang;
     }
