Index: components/registry/src/java/org/apache/jetspeed/om/portlet/impl/PortletApplicationDefinitionImpl.java
===================================================================
RCS file: /home/cvspublic/jakarta-jetspeed-2/components/registry/src/java/org/apache/jetspeed/om/portlet/impl/PortletApplicationDefinitionImpl.java,v
retrieving revision 1.18
diff -u -b -r1.18 PortletApplicationDefinitionImpl.java
--- components/registry/src/java/org/apache/jetspeed/om/portlet/impl/PortletApplicationDefinitionImpl.java	14 Aug 2004 00:21:30 -0000	1.18
+++ components/registry/src/java/org/apache/jetspeed/om/portlet/impl/PortletApplicationDefinitionImpl.java	15 Aug 2004 12:24:20 -0000
@@ -19,9 +19,11 @@
 import java.io.Serializable;
 import java.util.ArrayList;
 import java.util.Collection;
+import java.util.Iterator;
 
 import org.apache.jetspeed.om.common.GenericMetadata;
 import org.apache.jetspeed.om.common.JetspeedServiceReference;
+import org.apache.jetspeed.om.common.Support;
 import org.apache.jetspeed.om.common.UserAttribute;
 import org.apache.jetspeed.om.common.UserAttributeRef;
 import org.apache.jetspeed.om.common.portlet.MutablePortletApplication;
@@ -39,7 +41,7 @@
  * @version $Id: PortletApplicationDefinitionImpl.java,v 1.2 2004/08/15 12:43:04 shinsuke Exp $
  * @since 1.0
  */
-public class PortletApplicationDefinitionImpl implements MutablePortletApplication, Serializable
+public class PortletApplicationDefinitionImpl implements MutablePortletApplication, Serializable, Support
 { 
     /**
      * Unique id of the application.  This serves as the primary key in database
@@ -371,4 +373,17 @@
         this.checksumLong = checksum;
         this.checksum = Long.toString(checksum);
     }
+    
+    /* (non-Javadoc)
+     * @see org.apache.jetspeed.om.common.Support#postLoad(java.lang.Object)
+     */
+    public void postLoad(Object parameter) throws Exception
+    {
+        Iterator portletDefinitions = getPortletDefinitions().iterator();
+        while (portletDefinitions.hasNext())
+        {
+            ((Support) portletDefinitions.next()).postLoad(this);
+        }
+    }
+
 }
