Index: portal/src/java/org/apache/jetspeed/container/url/impl/AbstractPortalURL.java
===================================================================
RCS file: /home/cvspublic/jakarta-jetspeed-2/portal/src/java/org/apache/jetspeed/container/url/impl/AbstractPortalURL.java,v
retrieving revision 1.10
diff -u -b -r1.10 AbstractPortalURL.java
--- portal/src/java/org/apache/jetspeed/container/url/impl/AbstractPortalURL.java	20 Aug 2004 03:07:42 -0000	1.10
+++ portal/src/java/org/apache/jetspeed/container/url/impl/AbstractPortalURL.java	25 Sep 2004 22:51:58 -0000
@@ -234,10 +234,25 @@
         // * navigational information
         // * control information
                         
+        String pathInfo = null;
+        String requestURI = context.getRequest().getRequestURI();
+        String servletPath = context.getRequest().getServletPath();
+        if (servletPath == null)
+        {
+            servletPath = "";
+        }
+
+        try
+        {
+            pathInfo = requestURI.substring(contextPath.length() + servletPath.length());
+        }
+        catch (IndexOutOfBoundsException e)
+        {
+            pathInfo = null;
+        }
 
-        if (context.getRequest().getPathInfo() != null)
+        if (pathInfo != null)
         {
-            String pathInfo = new String(context.getRequest().getPathInfo());
             // DST: TODO: why do we need to parse "." as well as "/"?
             // this is creating a problem with params like "default.psml"
             //StringTokenizer tokenizer = new StringTokenizer(pathInfo, "/.");
@@ -458,7 +473,7 @@
     {
         startControlParameter.put(
             pcp.encodeRenderParamName(portletWindow, name),
-            pcp.encodeRenderParamValues(values));
+            pcp.encodeRenderParamValues(values, context.getCharacterEncoding()));
 
     }
 
@@ -476,7 +491,7 @@
     
     public String[] getRenderParamValues(PortletWindow window, String paramName)
     {
-        return pcp.getRenderParamValues(window, paramName);
+        return pcp.getRenderParamValues(window, paramName, context.getCharacterEncoding());
     }
 
     public PortletWindow getPortletWindowOfAction()
@@ -496,7 +511,7 @@
     
     public void setRenderParam(PortletWindow window, String name, String[] values)
     {
-        pcp.setRenderParam(window, name, values);
+        pcp.setRenderParam(window, name, values, context.getCharacterEncoding());
     }
     
     public void setMode(PortletWindow window, PortletMode mode) 
