Index: portal/src/java/org/apache/jetspeed/container/url/impl/PortalControlParameterImpl.java
===================================================================
RCS file: /home/cvspublic/jakarta-jetspeed-2/portal/src/java/org/apache/jetspeed/container/url/impl/PortalControlParameterImpl.java,v
retrieving revision 1.6
diff -u -b -r1.6 PortalControlParameterImpl.java
--- portal/src/java/org/apache/jetspeed/container/url/impl/PortalControlParameterImpl.java	16 Jun 2004 02:32:37 -0000	1.6
+++ portal/src/java/org/apache/jetspeed/container/url/impl/PortalControlParameterImpl.java	25 Sep 2004 22:52:12 -0000
@@ -15,6 +15,9 @@
  */
 package org.apache.jetspeed.container.url.impl;
 
+import java.io.UnsupportedEncodingException;
+import java.net.URLDecoder;
+import java.net.URLEncoder;
 import java.util.ArrayList;
 import java.util.Iterator;
 import java.util.List;
@@ -26,7 +29,7 @@
 
 import org.apache.jetspeed.Jetspeed;
 import org.apache.jetspeed.container.session.NavigationalStateComponent;
-import org.apache.jetspeed.container.url.*;
+import org.apache.jetspeed.container.url.PortalControlParameter;
 import org.apache.jetspeed.container.url.PortalURL;
 import org.apache.jetspeed.container.window.PortletWindowAccessor;
 import org.apache.pluto.om.window.PortletWindow;
@@ -154,10 +157,10 @@
         return returnvalue.iterator();
     }
 
-    public String[] getRenderParamValues(PortletWindow window, String paramName)
+    public String[] getRenderParamValues(PortletWindow window, String paramName, String encoding)
     {
         String encodedValues = (String) stateFullControlParameter.get(encodeRenderParamName(window, paramName));
-        String[] values = decodeRenderParamValues(encodedValues);
+        String[] values = decodeRenderParamValues(encodedValues, encoding);
         return values;
     }
 
@@ -215,10 +218,10 @@
         stateFullControlParameter.put(url.getModeKey(window), mode.toString());
     }
 
-    public void setRenderParam(PortletWindow window, String name, String[] values)
+    public void setRenderParam(PortletWindow window, String name, String[] values, String encoding)
     {
         String encodedKey = encodeRenderParamName(window, name);
-        String encodedValue = encodeRenderParamValues(values);
+        String encodedValue = encodeRenderParamValues(values, encoding);
         stateFullControlParameter.put(encodedKey, encodedValue);
         // setRequestParam(encodedKey, values);
     }
@@ -264,14 +267,14 @@
         return returnvalue.toString();
     }
 
-    public String encodeRenderParamValues(String[] paramValues)
+    public String encodeRenderParamValues(String[] paramValues, String encoding)
     {
         StringBuffer returnvalue = new StringBuffer(100);
         returnvalue.append(paramValues.length);
         for (int i = 0; i < paramValues.length; i++)
         {
             returnvalue.append("_");
-            returnvalue.append(encodeValue(paramValues[i]));
+            returnvalue.append(encodeValue(paramValues[i], encoding));
         }
         return returnvalue.toString();
     }
@@ -296,7 +299,7 @@
         return name;
     }
 
-    private String[] decodeRenderParamValues(String encodedParamValues)
+    private String[] decodeRenderParamValues(String encodedParamValues, String encoding)
     {
         StringTokenizer tokenizer = new StringTokenizer(encodedParamValues, "_");
         if (!tokenizer.hasMoreTokens())
@@ -308,13 +311,20 @@
         {
             if (!tokenizer.hasMoreTokens())
                 return null;
-            values[i] = decodeValue(tokenizer.nextToken());
+            values[i] = decodeValue(tokenizer.nextToken(), encoding);
         }
         return values;
     }
 
-    private String decodeValue(String value)
+    private String decodeValue(String value, String encoding)
     {
+        try
+        {
+            value = URLDecoder.decode(value, encoding);
+        }
+        catch (UnsupportedEncodingException e)
+        {
+        }
         value = StringUtils.replace(value, "0x1", "_" );
         value = StringUtils.replace(value, "0x2", "." );
         value = StringUtils.replace(value, "0x3", "/" );
@@ -326,7 +336,7 @@
         return value;
     }
 
-    private String encodeValue(String value)
+    private String encodeValue(String value ,String encoding)
     {
         value = StringUtils.replace(value, "_", "0x1" );
         value = StringUtils.replace(value, ".", "0x2" );
@@ -336,6 +346,13 @@
         value = StringUtils.replace(value, "<", "0x6" );
         value = StringUtils.replace(value, ">", "0x7" );
         value = StringUtils.replace(value, " ", "0x8" );        
+        try
+        {
+            value = URLEncoder.encode(value, encoding);
+        }
+        catch (UnsupportedEncodingException e)
+        {
+        }
         return value;
     }
     
