Index: portal/src/java/org/apache/jetspeed/deployment/impl/DeployPortletAppEventListener.java
===================================================================
RCS file: /home/cvspublic/jakarta-jetspeed-2/portal/src/java/org/apache/jetspeed/deployment/impl/DeployPortletAppEventListener.java,v
retrieving revision 1.17
diff -u -b -r1.17 DeployPortletAppEventListener.java
--- portal/src/java/org/apache/jetspeed/deployment/impl/DeployPortletAppEventListener.java	16 Aug 2004 18:31:19 -0000	1.17
+++ portal/src/java/org/apache/jetspeed/deployment/impl/DeployPortletAppEventListener.java	18 Sep 2004 22:15:35 -0000
@@ -21,6 +21,7 @@
 import org.apache.jetspeed.deployment.DeploymentException;
 import org.apache.jetspeed.deployment.DeploymentObject;
 import org.apache.jetspeed.factory.PortletFactory;
+import org.apache.jetspeed.om.common.portlet.MutablePortletApplication;
 import org.apache.jetspeed.tools.pamanager.PortletApplicationManagement;
 import org.apache.jetspeed.util.DirectoryHelper;
 import org.apache.jetspeed.util.FileSystemHelper;
@@ -214,7 +215,9 @@
                 appNameToFile.put(deploymentObj.getPath(), id);
                 if (isLocal)
                 {                
-                    portletFactory.addClassLoader(paWar.createClassloader(getClass().getClassLoader()));
+                    portletFactory.addClassLoader(
+                        registry.getPortletApplicationByIdentifier(id).getId().toString(),
+                        paWar.createClassloader(getClass().getClassLoader()));
                 }
                 else
                 {
@@ -223,7 +226,9 @@
                         ClassLoader classloader = createPortletClassloader(getClass().getClassLoader(), id);
                         if (classloader != null)
                         {
-                            portletFactory.addClassLoader(classloader);
+                            portletFactory.addClassLoader(
+                                registry.getPortletApplicationByIdentifier(id).getId().toString(),
+                                classloader);
                         }
                     }
                     catch (IOException e1)
@@ -243,7 +248,13 @@
                 {
                     log.info(fileName + " will be registered as a local portlet applicaiton.");                    
                     pam.register(paWar);
-                    portletFactory.addClassLoader(paWar.createClassloader(getClass().getClassLoader()));
+                    MutablePortletApplication mpa = registry.getPortletApplicationByIdentifier(id);
+                    if (mpa != null)
+                    {
+                        portletFactory.addClassLoader(
+                            mpa.getId().toString(),
+                            paWar.createClassloader(getClass().getClassLoader()));
+                    }
                 }
                 else
                 {
@@ -254,7 +265,11 @@
                         ClassLoader classloader = createPortletClassloader(getClass().getClassLoader(), id);
                         if (classloader != null)
                         {
-                            portletFactory.addClassLoader(classloader);
+                            MutablePortletApplication mpa = registry.getPortletApplicationByIdentifier(id);
+                            if (mpa != null)
+                            {
+                                portletFactory.addClassLoader(mpa.getId().toString(), classloader);
+                            }
                         }
                     }
                     catch (IOException e1)
