Index: portal/src/java/org/apache/jetspeed/engine/servlet/ServletRequestFactoryImpl.java
===================================================================
RCS file: /home/cvspublic/jakarta-jetspeed-2/portal/src/java/org/apache/jetspeed/engine/servlet/ServletRequestFactoryImpl.java,v
retrieving revision 1.3
diff -u -b -r1.3 ServletRequestFactoryImpl.java
--- portal/src/java/org/apache/jetspeed/engine/servlet/ServletRequestFactoryImpl.java	8 Mar 2004 00:26:30 -0000	1.3
+++ portal/src/java/org/apache/jetspeed/engine/servlet/ServletRequestFactoryImpl.java	30 Jul 2004 22:22:37 -0000
@@ -15,10 +15,12 @@
  */
 package org.apache.jetspeed.engine.servlet;
 
+import java.io.UnsupportedEncodingException;
 import java.util.Map;
 import javax.servlet.http.HttpServletRequest;
 import javax.servlet.ServletConfig;
 
+import org.apache.jetspeed.request.JetspeedRequestContext;
 import org.apache.pluto.om.window.PortletWindow;
 
 /**
@@ -47,6 +49,21 @@
     {
         // TODO: use pool here
         HttpServletRequest servletRequest = new ServletRequestImpl(request, window);
+
+        // Set page encoding in order to parse the form data correctly        
+        String preferedEnc = (String) request.getAttribute(JetspeedRequestContext.PREFERED_CHARACTERENCODING_KEY);
+        if (preferedEnc != null)
+        {
+            try
+            {
+                servletRequest.setCharacterEncoding(preferedEnc);
+            }
+            catch (UnsupportedEncodingException e)
+            {
+                ;
+            }
+        }
+
         return servletRequest;
     }
     
